<template>
  <div class="q-pa-md">
    <div class="column">
      <div class="col" style="text-align: right">
        <q-btn tag="a" to="/badan-usaha/tambah" color="blue" icon="add" label="Tambah Badan Usaha" />
      </div>
    </div>

    <div class="column flex-center">
      <div class="col" style="margin-top: 10px; width: 100%">
        <q-table
          class="my-sticky-header-table"
          title="Daftar Referensi Badan Usaha"
          :data="dataTable"
          :columns="columns"
          row-key="name"
        >
          <template v-slot:top-right style="color: white !important;">
            <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Badan Usaha" color="white">
              <template v-slot:append style="color: white">
                <q-icon name="search"  />
              </template>
            </q-input>
          </template>

          <template v-slot:body="props">
            <q-tr :props="props" :key="`m_${props.row.index}`">
              <q-td
                key="index"
                :props="props"
              >
                {{ props.row.index }}.
              </q-td>
              <q-td key="business_code" :props="props" >{{ props.row.business_code }}</q-td>
              <q-td key="business_entity" :props="props" >{{ props.row.business_entity }}</q-td>
              <q-td style="width: 370px" key="desc" :props="props" >{{ props.row.desc }}</q-td>
              <q-td key="status" :props="props" >
                <q-badge align="middle" color="blue" v-if="props.row.status">Aktif</q-badge>
                <q-badge align="middle" color="red" v-else>Tidak Aktif</q-badge>
              </q-td>
              <q-td key="creator" :props="props" >{{ props.row.creator }}</q-td>
              <q-td key="tanggal_update" :props="props" >{{ props.row.tanggal_update }}</q-td>
              <q-td key="aksi" :props="props" >
                <q-btn
                  padding="none"
                  color="primary"
                  icon="edit"
                  :to="`badan-usaha/edit/${props.row.id}`"
                />
                <q-btn
                  style="margin-left: 3px"
                  padding="none"
                  color="primary"
                  icon="delete"
                  :to="`badan-usaha/hapus/${props.row.id}`"
                />
              </q-td>
            </q-tr>
          </template>
        </q-table>
      </div>
    </div>

  </div>
</template>

<script>
  export default {
    name: "ListBadanUsaha",

    data () {
      return {
        filter: null,
        columns: [
          {
            name: 'index',
            required: true,
            label: 'No',
            align: 'left',
            field: 'index',
            format: val => `${val}`,
            sortable: true
          },
          { name: 'business_code', align:'left', label: 'Kode', field: 'business_code', sortable: true },
          { name: 'business_entity', label: 'Badan Usaha', field: 'business_entity', sortable: true },
          { name: 'desc', label: 'Deskripsi', field: 'desc' },
          { name: 'status', label: 'Status', field: 'status' },
          { name: 'creator', label: 'Update By', field: 'creator' },
          { name: 'tanggal_update', label: 'Last Update', field: 'tanggal_update' },
          { name: 'aksi', label: 'Aksi', field: 'id' }
        ],
        dataTable: [],
      }
    },

    beforeMount() {
      this.getBadanUsaha();
    },

    methods: {
      async getBadanUsaha() {
        let dataApi = {
          methods: "get",
          url: "api/business/list",
          headers: {
            Authorization: "Bearer " + localStorage.getItem("token")
          }
        }

        this.$q.loading.show()
        await this.$axios(dataApi)
        .then(sukses => {
          this.dataTable = sukses.data.data
          this.dataTable.forEach((row, index) => {
            row.index = index + 1
            let update = new Date(row.updated_at);
            row.tanggal_update = update.toLocaleDateString() + " , " +  update.toLocaleTimeString();
          })
        })
        .catch(error => {
          console.log(error.response)

        })
        .then(selalu => {
          this.$q.loading.hide()
        })
      }
    }
  }
</script>

<style lang="sass">
  .q-table--no-wrap td
    white-space: normal

  .my-sticky-header-table

    .q-table__top,
    .q-table__bottom,
    thead tr:first-child th
      /* bg color is important for th; just specify one */
      font-size: 16px

    thead tr th
      position: sticky
      z-index: 1
    thead tr:first-child th
      top: 0

    /* this is when the loading indicator appears */
    &.q-table--loading thead tr:last-child th
      /* height of all previous header rows */
      top: 48px


</style>

<style>
thead {
  background-color: #c2c2c2;
}
.q-table__title {
  font-weight: bold;
}
.text-left, .text-right {
  text-align: center !important;
}
</style>
